from lamin_vault.client.postgres._create_or_update_role_and_policy_db import (
    create_or_update_role_and_policy_db,
)


def set_admin_db_role(vault_admin_client, instance_id, account_id):
    admin_role_creation_statements = [
        "CREATE ROLE \"{{name}}\" WITH LOGIN PASSWORD '{{password}}' VALID UNTIL"
        " '{{expiration}}';",
        'GRANT CREATE ON SCHEMA public TO "{{name}}";',
        "GRANT SELECT, INSERT, UPDATE, DELETE ON ALL TABLES IN SCHEMA public TO"
        ' "{{name}}";',
        "ALTER DEFAULT PRIVILEGES IN SCHEMA public GRANT SELECT, INSERT, UPDATE, DELETE"
        ' ON TABLES TO "{{name}}";',
        'GRANT USAGE, SELECT, UPDATE ON ALL SEQUENCES IN SCHEMA public TO "{{name}}";',
        "ALTER DEFAULT PRIVILEGES IN SCHEMA public GRANT USAGE, SELECT, UPDATE ON"
        ' SEQUENCES TO "{{name}}";',
    ]
    create_or_update_role_and_policy_db(
        vault_admin_client, instance_id, account_id, admin_role_creation_statements
    )


def set_write_db_role(vault_admin_client, instance_id, account_id):
    write_role_creation_statements = [
        "CREATE ROLE \"{{name}}\" WITH LOGIN PASSWORD '{{password}}' VALID UNTIL"
        " '{{expiration}}';",
        'GRANT SELECT, INSERT, UPDATE ON ALL TABLES IN SCHEMA public TO "{{name}}";',
        "ALTER DEFAULT PRIVILEGES IN SCHEMA public GRANT SELECT, INSERT, UPDATE ON"
        ' TABLES TO "{{name}}";',
        'GRANT USAGE, SELECT, UPDATE ON ALL SEQUENCES IN SCHEMA public TO "{{name}}";',
        "ALTER DEFAULT PRIVILEGES IN SCHEMA public GRANT USAGE, SELECT, UPDATE ON"
        ' SEQUENCES TO "{{name}}";',
    ]
    create_or_update_role_and_policy_db(
        vault_admin_client, instance_id, account_id, write_role_creation_statements
    )


def set_read_db_role(vault_admin_client, instance_id, account_id):
    read_role_creation_statements = [
        "CREATE ROLE \"{{name}}\" WITH LOGIN PASSWORD '{{password}}' VALID UNTIL"
        " '{{expiration}}';",
        'GRANT SELECT ON ALL TABLES IN SCHEMA public TO "{{name}}";',
        "ALTER DEFAULT PRIVILEGES IN SCHEMA public GRANT SELECT ON TABLES TO"
        ' "{{name}}";',
    ]
    create_or_update_role_and_policy_db(
        vault_admin_client, instance_id, account_id, read_role_creation_statements
    )
